<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LeaderZooKeeperServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">LeaderZooKeeperServer.java</span></div><h1>LeaderZooKeeperServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.IOException;

import org.apache.zookeeper.KeeperException.SessionExpiredException;
import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.DataTreeBean;
import org.apache.zookeeper.server.FinalRequestProcessor;
import org.apache.zookeeper.server.PrepRequestProcessor;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.ServerCnxn;
import org.apache.zookeeper.server.SessionTrackerImpl;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;

/**
 * 
 * Just like the standard ZooKeeperServer. We just replace the request
 * processors: PrepRequestProcessor -&gt; ProposalRequestProcessor -&gt;
 * CommitProcessor -&gt; Leader.ToBeAppliedRequestProcessor -&gt;
 * FinalRequestProcessor
 */
public class LeaderZooKeeperServer extends QuorumZooKeeperServer {
    CommitProcessor commitProcessor;

    /**
     * @param port
     * @param dataDir
     * @throws IOException
     */
    LeaderZooKeeperServer(FileTxnSnapLog logFactory, QuorumPeer self,
            DataTreeBuilder treeBuilder, ZKDatabase zkDb) throws IOException {
<span class="fc" id="L51">        super(logFactory, self.tickTime, self.minSessionTimeout,</span>
                self.maxSessionTimeout, treeBuilder, zkDb, self);
<span class="fc" id="L53">    }</span>

    public Leader getLeader(){
<span class="fc" id="L56">        return self.leader;</span>
    }
    
    @Override
    protected void setupRequestProcessors() {
<span class="fc" id="L61">        RequestProcessor finalProcessor = new FinalRequestProcessor(this);</span>
<span class="fc" id="L62">        RequestProcessor toBeAppliedProcessor = new Leader.ToBeAppliedRequestProcessor(</span>
<span class="fc" id="L63">                finalProcessor, getLeader().toBeApplied);</span>
<span class="fc" id="L64">        commitProcessor = new CommitProcessor(toBeAppliedProcessor,</span>
<span class="fc" id="L65">                Long.toString(getServerId()), false,</span>
<span class="fc" id="L66">                getZooKeeperServerListener());</span>
<span class="fc" id="L67">        commitProcessor.start();</span>
<span class="fc" id="L68">        ProposalRequestProcessor proposalProcessor = new ProposalRequestProcessor(this,</span>
                commitProcessor);
<span class="fc" id="L70">        proposalProcessor.initialize();</span>
<span class="fc" id="L71">        firstProcessor = new PrepRequestProcessor(this, proposalProcessor);</span>
<span class="fc" id="L72">        ((PrepRequestProcessor)firstProcessor).start();</span>
<span class="fc" id="L73">    }</span>

    @Override
    public int getGlobalOutstandingLimit() {
<span class="fc" id="L77">        return super.getGlobalOutstandingLimit() / (self.getQuorumSize() - 1);</span>
    }
    
    @Override
    public void createSessionTracker() {
<span class="fc" id="L82">        sessionTracker = new SessionTrackerImpl(this, getZKDatabase()</span>
<span class="fc" id="L83">                .getSessionWithTimeOuts(), tickTime, self.getId(),</span>
<span class="fc" id="L84">                getZooKeeperServerListener());</span>
<span class="fc" id="L85">    }</span>
    
    @Override
    protected void startSessionTracker() {
<span class="fc" id="L89">        ((SessionTrackerImpl)sessionTracker).start();</span>
<span class="fc" id="L90">    }</span>


    public boolean touch(long sess, int to) {
<span class="fc" id="L94">        return sessionTracker.touchSession(sess, to);</span>
    }

    @Override
    protected void registerJMX() {
        // register with JMX
        try {
<span class="fc" id="L101">            jmxDataTreeBean = new DataTreeBean(getZKDatabase().getDataTree());</span>
<span class="fc" id="L102">            MBeanRegistry.getInstance().register(jmxDataTreeBean, jmxServerBean);</span>
<span class="fc" id="L103">        } catch (Exception e) {</span>
<span class="fc" id="L104">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L105">            jmxDataTreeBean = null;</span>
<span class="fc" id="L106">        }</span>
<span class="fc" id="L107">    }</span>

    public void registerJMX(LeaderBean leaderBean,
            LocalPeerBean localPeerBean)
    {
        // register with JMX
<span class="pc bpc" id="L113" title="1 of 2 branches missed.">        if (self.jmxLeaderElectionBean != null) {</span>
            try {
<span class="nc" id="L115">                MBeanRegistry.getInstance().unregister(self.jmxLeaderElectionBean);</span>
<span class="nc" id="L116">            } catch (Exception e) {</span>
<span class="nc" id="L117">                LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L118">            }</span>
<span class="nc" id="L119">            self.jmxLeaderElectionBean = null;</span>
        }

        try {
<span class="fc" id="L123">            jmxServerBean = leaderBean;</span>
<span class="fc" id="L124">            MBeanRegistry.getInstance().register(leaderBean, localPeerBean);</span>
<span class="fc" id="L125">        } catch (Exception e) {</span>
<span class="fc" id="L126">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L127">            jmxServerBean = null;</span>
<span class="fc" id="L128">        }</span>
<span class="fc" id="L129">    }</span>

    @Override
    protected void unregisterJMX() {
        // unregister from JMX
        try {
<span class="fc bfc" id="L135" title="All 2 branches covered.">            if (jmxDataTreeBean != null) {</span>
<span class="fc" id="L136">                MBeanRegistry.getInstance().unregister(jmxDataTreeBean);</span>
            }
<span class="nc" id="L138">        } catch (Exception e) {</span>
<span class="nc" id="L139">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L140">        }</span>
<span class="fc" id="L141">        jmxDataTreeBean = null;</span>
<span class="fc" id="L142">    }</span>

    protected void unregisterJMX(Leader leader) {
        // unregister from JMX
        try {
<span class="fc bfc" id="L147" title="All 2 branches covered.">            if (jmxServerBean != null) {</span>
<span class="fc" id="L148">                MBeanRegistry.getInstance().unregister(jmxServerBean);</span>
            }
<span class="nc" id="L150">        } catch (Exception e) {</span>
<span class="nc" id="L151">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L152">        }</span>
<span class="fc" id="L153">        jmxServerBean = null;</span>
<span class="fc" id="L154">    }</span>
    
    @Override
    public String getState() {
<span class="fc" id="L158">        return &quot;leader&quot;;</span>
    }

    /**
     * Returns the id of the associated QuorumPeer, which will do for a unique
     * id of this server. 
     */
    @Override
    public long getServerId() {
<span class="fc" id="L167">        return self.getId();</span>
    }    
    
    @Override
    protected void revalidateSession(ServerCnxn cnxn, long sessionId,
        int sessionTimeout) throws IOException {
<span class="fc" id="L173">        super.revalidateSession(cnxn, sessionId, sessionTimeout);</span>
        try {
            // setowner as the leader itself, unless updated
            // via the follower handlers
<span class="fc" id="L177">            setOwner(sessionId, ServerCnxn.me);</span>
<span class="nc" id="L178">        } catch (SessionExpiredException e) {</span>
            // this is ok, it just means that the session revalidation failed.
<span class="fc" id="L180">        }</span>
<span class="fc" id="L181">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>